#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <sys/types.h>
#include <rsbac/types.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80],tmp2[120];
/*  char *key = (void *) 0; */
  int i;
  union rsbac_attribute_value_t value;
  union rsbac_target_id_t tid;
  enum rsbac_attribute_t attr;
  
  if (argc == 3)
    {
      attr = get_attribute_nr(argv[2]);
      if(attr == A_none)
        {
          printf("%s: Invalid Attribute %s!\n", argv[0], argv[2]);
          exit(1);
        }
      value.dummy = -1;
      tid.process = strtol(argv[1],0,0);
      res = rsbac_get_attr(T_PROCESS, &tid, attr, &value);
      if(res)
        {
          if((errno<RSBAC_EPERM) || (errno > RSBAC_EDECISIONMISMATCH))
            {
              if(errno == 1)
                printf("error: EPERM\n");
              else
                printf("%s: errno: %i\n", argv[0], errno);
            }
          else
            {
              get_error_name(tmp1,errno);
              printf("%s: error: %s\n", argv[0], tmp1);
            }
          exit(1);
        }
      else
        {
          switch(attr)
            {
              case A_owner: printf("%i\n",value.owner);
                            break;
              default:      printf("%i\n",value.dummy);
            }
          exit(0);
        }
    }
  else
    {
      printf("Use: %s process attribute\n", argv[0]);  
      printf("- attribute (string) and returned value = see following list:\n");
      for (i=0;i<15;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
/*      printf("-- press return --");
      scanf("%c", key); */
      for (i=15;i<A_none;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
    }
    
  exit(1);
}

