#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <sys/types.h>
#include <rsbac/types.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80],tmp2[120];
/*  char *key = (void *) 0; */
  int i=0;
  union rsbac_attribute_value_t value;
  union rsbac_target_id_t tid;
  enum rsbac_attribute_t attr;
  struct passwd * user_info_p;
  
  if (argc == 3)
    {
      value.dummy = -1;
      if(   (!(user_info_p = getpwnam(argv[1])))
         && (   (!(user_info_p = getpwuid(strtol(argv[1],0,0))))
             || (!(user_info_p->pw_uid) && strcmp("0",argv[1])) )
        )
          {
            printf("Invalid user %s!\n", argv[1]);
            exit(1);
          }
      tid.user = user_info_p->pw_uid;
      if(!strcmp("user_nr",argv[2]))
        {
          printf("%i\n", user_info_p->pw_uid);
          exit(0);
        }
      if(!strcmp("user_name",argv[2]))
        {
          printf("%s\n", user_info_p->pw_name);
          exit(0);
        }
      if(!strcmp("full_name",argv[2]))
        {
          printf("%s\n", user_info_p->pw_gecos);
          exit(0);
        }

      attr = get_attribute_nr(argv[2]);
      if(attr == A_none)
        {
          printf("%s: Invalid Attribute %s!\n", argv[0], argv[2]);
          exit(1);
        }

      res = rsbac_get_attr(T_USER, &tid, attr, &value);
      if(res)
        {
          if((errno<RSBAC_EPERM) || (errno > RSBAC_EDECISIONMISMATCH))
            {
              if(errno == 1)
                printf("error: EPERM\n");
              else
                printf("%s: errno: %i\n", argv[0], errno);
            }
          else
            {
              get_error_name(tmp1,errno);
              printf("%s: error: %s\n", argv[0], tmp1);
            }
          exit(1);
        }
      else
        {
          printf("%i\n",value.dummy);
          exit(0);
        }
    }
  else
    {
      printf("Use: %s user attribute\n\n", argv[0]);  
      printf("- attribute (string) and returned value = see following list:\n");
      for (i=0;i<15;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
/*      printf("-- press return --");
      scanf("%c", key); */
      for (i=15;i<A_none;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
    }
  exit(1);
}

