#include <stdio.h>
#include <stdlib.h>
#include <rsbac/types.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80],tmp2[120];
  char * key = (void *) 0;
  int i;
  int val;
  union rsbac_attribute_value_t value;
  enum rsbac_target_t target;
  enum rsbac_attribute_t attr;
  
  if (argc == 5)
    {
      target = get_target_nr(argv[1]);
      attr = get_attribute_nr(argv[3]);
      val = strtol(argv[4],0,0);
      value.dummy = val;
      res = rsbac_set_attr_n(target, argv[2], attr, &value);
      if(res)
        {
          if((errno<RSBAC_EPERM) || (errno > RSBAC_EDECISIONMISMATCH))
            {
              if(errno == 1)
                printf("%s: Access denied (error: EPERM)\n", argv[0]);
              else
                printf("%s: errno: %i\n", argv[0], errno);
            }
          else
            {
              get_error_name(tmp1,errno);
              printf("%s: error: %s\n", argv[0], tmp1);
            }
          exit(1);
        }
      exit(0);
    }
  else
    {
      printf("Use: %s target-type attribute value file/dirname(s)\n", argv[0]);  
      printf("- target-type = FILE or DIR,\n");
      printf("- attribute (string) and value (integer) = see following list:\n");
      for (i=0;i<16;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
      printf("-- press return --");
      scanf("%c", key);
      for (i=16;i<A_none;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
    }
  exit(1);
}

