#include <stdio.h>
#include <stdlib.h>
#include <rsbac/types.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80],tmp2[120];
  char *key = (void *) 0;
  int i;
  union rsbac_attribute_value_t value;
  union rsbac_target_id_t tid;
  enum rsbac_ipc_type_t ipc_target;
  enum rsbac_attribute_t attr;
  struct rsbac_ipc_t ipc_id;
  rsbac_pid_t pid;
  int    sid;
  
  if ((argc == 5)||(argc == 6))
    {
      strcpy(tmp2,argv[0]);
      if((ipc_target = get_ipc_target_nr(argv[1])) == I_none)
        {
          printf("%s: Invalid IPC type %s!\n", tmp2, argv[1]);
          exit(1);
        }
      ipc_id.type = ipc_target;
      if((ipc_target == I_socket) && (argc == 6))
        {
          pid = strtol(argv[2],0,0);
          sid = strtol(argv[3],0,0);
          ipc_id.id_nr = rsbac_create_ipc_sock_id(pid,sid);
          argv++;
        }
      else
          ipc_id.id_nr = strtol(argv[2],0,0);

      attr = get_attribute_nr(argv[3]);
      if(attr == A_none)
        {
          printf("%s: Invalid Attribute %s!\n", tmp2, argv[3]);
          exit(1);
        }
      tid.ipc = ipc_id;

      value.dummy = strtol(argv[4],0,0);
      res = rsbac_set_attr(T_IPC, &tid, attr, &value);
      if(res)
        {
          if((errno<RSBAC_EPERM) || (errno > RSBAC_EDECISIONMISMATCH))
            {
              if(errno == 1)
                printf("%s: Access denied (error: EPERM)\n", tmp2);
              else
                printf("%s: errno: %i\n", tmp2, errno);
            }
          else
            {
              get_error_name(tmp1,errno);
              printf("%s: error: %s\n", tmp2, tmp1);
            }
          exit(1);
        }
      else
        {
          printf("%i\n",value.dummy);
          exit(0);
        }
    }
  else
    {
      printf("Use: %s (socket process-id socket-id)|(ipc-type id) attribute value\n",
             argv[0]);  
      printf("- ipc-types: sem, msg, shm, socket,\n");
      printf("- attribute (string) and value = see following list:\n");
      for (i=0;i<16;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
      printf("-- press return --");
      scanf("%c", key);
      for (i=16;i<A_none;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
    }
  exit(1);
}

