#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <rsbac/types.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80],tmp2[120];
  int i;
  union rsbac_attribute_value_t value;
  union rsbac_target_id_t tid;
  enum rsbac_attribute_t attr;
  
  if (argc == 4)
    {
      attr = get_attribute_nr(argv[2]);
      if(attr == A_none)
        {
          printf("%s: Invalid Attribute %s!\n", argv[0], argv[2]);
          exit(1);
        }
      switch(attr)
        {
          case A_owner: value.owner = strtol(argv[3],0,0);
                        break;
          default: value.dummy = strtol(argv[3],0,0);
        }
      tid.process = strtol(argv[1],0,0);
      res = rsbac_set_attr(T_PROCESS, &tid, attr, &value);
      if(res)
        {
          if((errno<RSBAC_EPERM) || (errno > RSBAC_EDECISIONMISMATCH))
            {
              if(errno == 1)
                printf("%s: Access denied (error: EPERM)\n", argv[0]);
              else
                printf("%s: errno: %i\n", argv[0], errno);
            }
          else
            {
              get_error_name(tmp1,errno);
              printf("%s: error: %s\n", argv[0], tmp1);
            }
          exit(1);
        }
      else
        exit(0);
    }
  else
    {
      printf("Use: %s process-id attribute value\n", argv[0]);  
      printf("- attribute (string) and value (integer) = see following list:\n");
      for (i=0;i<15;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
      for (i=15;i<A_none;i++)
        {
          get_attribute_name(tmp1,i);
          get_attribute_param(tmp2,i);
          printf("%s \t%s\n",tmp1,tmp2);
        }
    }
  exit(1);
}

